#include "robot.h"

/* global variables */
int sock;
int mana;
int maxmana;
int hps;
int maxhps;
int v;
int maxv;
int gold;
int exp;
int mage_level;
int cleric_level;
int goal;
int running;
int resting;
char leader[50] = "none";

char *help_spells[] = {"armor", "bless", "cure blind", "cure c", "cure l", 
		       "detect e", "detect m", "detect i", "remove curse",
		       "remove poison", "sense life", "know align",
		       "remove paral", "cure serious", "refresh", "sec",
		       "aid", "inv", "str", "infravision", "water breath",
		       "true sight", "shield", "minor tr"};
int num_help = 24;
		       
void must_cast(char *,char *);
void go_to(int);
void prac_help(char *);
void maintain_spells(void);
void check_inventory(char *);
void locate(char *,char *);

int main(int argc, char *argv[]) {

  int i, connectresult;
  struct sockaddr_in sockaddr;
  struct hostent *hp;
  
  if (argc != 2) {
    printf("Incorrect command line arguments.\n");
    printf("Please use:\n");
    printf("%% ./robot <port>\n");
    printf("where <port> is the port of the mud to try.\n");
    exit(0);
  }
  if (!(isdigit(*(argv[1])))) {
    printf("Incorrect command line arguments.\n");
    printf("Please use:\n");
    printf("%% ./robot <port>\n");
    printf("where <port> is the NUMBER of the mud port to try.\n");
    exit(0);
  }
  signal(SIGINT,quitbot);
  signal(SIGTERM,quitbot);
  signal(SIGALRM,alarmfunct);
  connect_mud(MUDHOST,argv[1]);
  robot();
  return 0;
}

void robot(void) {

  char *msg;
  char *cp1, *cp2;
  int count = 0;
  int exp_earned;
  char buf[50];

  hps = maxhps = mana = maxmana = v = maxv = 0;
  mage_level = cleric_level = goal = 0;
  running = 1;
  resting = 1;
  sleep(2);
  sendmud(MYNAME);
  sleep(1);
  sendmud(MYPASS);
  sleep(2);
  sendmud("\n");
  sleep(1);
  sendmud("1");
  sendmud("cast \'detect i\' hobbes");
  sendmud("hold feather");
  sendmud("wi black-longsword");
  sendmud("wear all");
  sendmud("wear iron");
  get_stats();

  /* main loop */
  while(1) {
    if (exp > goal)
      running = 0;
    count++;
    msg = getmud();
    if ((mana == maxmana) && (!strcmp(leader,"none"))) {
      sendmud("cast \'golem\'");
      sendmud("d");
      sendmud("o golem sl");
      sendmud("u");
      get_stats();
      maintain_spells();
      count = 0;
    }
    if (strstr(msg,"looks at you"))
      sendmud("smile");
    if ((strstr(msg,"tells you")) || ((strstr(msg,"says")) &&
	((strstr(msg,MYNAME)) || (strstr(msg,MYLOWNAME)))))
      parse_command(msg);
    if (strstr(msg,"gives you")) {
      sendmud("say Thanks!");
      sendmud("wear all");
    }
    if ((cp1=strstr(msg,"has arrived")) ||
        (cp1=strstr(msg,"appears")) ||
	(cp1=strstr(msg,"has entered"))) {
      if ((mana >= 100) && (!(strcmp(leader,"none")))) {
	cp2 = cp1--;
	cp1--;
	cp1--;
	while((cp1 != msg) && (*cp1 != ' '))
	  cp1--;
	if (cp1 != msg)
	  cp1++;
	*cp2 = '\0';
	prac_help(cp1);
	*cp2 = ' ';
      }
    }
    if (strstr(msg,HUNGER)) {
      sendmud("cast \'create f\'");
      sendmud("g mushroom");
      sendmud("eat mushroom");
    }
    if (strstr(msg,THIRST)) {
      sendmud("cast \'create w\' water");
      sendmud("cast \'create w\' water");
      sendmud("dr water");
    }
    if (strstr(msg,"You can\'t summon enough energy to cast")) {
      sendmud("say Ack! I\'m outta mana.");
      if (!strcmp(leader,"none")) {
	sendmud("rest");
      }
    }
    if (strstr(msg,"Nah") && strstr(msg,"too relaxed")) {
      sendmud("stand");
      sendmud("score");
    }
    if (cp1=strstr(msg,"share of")) {
      sendmud("save");
      sscanf(cp1,"share of %d experience",&exp_earned);
      sprintf(buf,"say %d experience.",exp_earned);
      sendmud(buf);
    }
    if ((strstr(msg,PROMPT)) && (strstr(msg,"H:"))) {
      cp1 = strstr(msg,"H:");
      sscanf(cp1,"H:%d M:%d V:%d",&hps,&mana,&v);
    }
    if (strstr(msg,"ByTheWay")) {
      sendmud("emote shakes his head and sighs.");
      sendmud("say I'll have to do something about that.");
      sendmud("emote ties a gag around Zeus' mouth.");
    }
    if (count == 150) {
      get_stats();
      maintain_spells();
      count = 0;
    }
  }
  return;
}
  
void get_stats(void) {

  char *msg;
  char *cp;
  char *p1;
  char smbuf[50];
  int cg,mg,dummy;

  sendmud("score");
  msg = getmud();
  while(!(strstr(msg," mana and ")))
    msg = getmud();
  cp = strstr(msg,"You have");
  p1 = strstr(msg,"movement");
  *p1 = '\0';
  sscanf(cp,"You have %d(%d) hit, %d(%d) mana and %d(%d)",
	 &hps, &maxhps, &mana, &maxmana, &v, &maxv);
  *p1 = ' ';
  while(!(strstr(msg," have scored ")))
    msg = getmud();
  cp = strstr(msg,"You have scored");
  p1 = strstr(msg,"coins");
  *p1 = '\0';
  sscanf(cp,"You have scored %d exp, and have %d gold", &exp, &gold);
  *p1 = ' ';
  if (hps < maxhps)
    sendmud("cast \'cure c\' hobbes");
  if (v < 60)
    sendmud("cast \'sec\' hobbes");
  if (goal > 0)
    return;
  while(!(strstr(msg,"Your levels")))
    msg = getmud();
  cp = strstr(msg,"M:");
  sscanf(cp,"M:%d",&mage_level);
  cp = strstr(msg,"C:");
  sscanf(cp,"C:%d",&cleric_level);
  sprintf(smbuf,"[%d]",cleric_level+1);
  sendmud("lev c");
  msg = getmud();
  while(!(strstr(msg,smbuf)))
    msg = getmud();
  cp = strstr(msg,smbuf);
  p1 = strstr(cp,"-");
  *p1 = '\0';
  sscanf(cp,"[%d] %d",&dummy,&cg);
  sprintf(smbuf,"[%d]",mage_level+1);
  sendmud(GARBAGE);
  while(!(strstr(msg,HUH)))
    msg = getmud();
  sendmud("lev m");
  while(!(strstr(msg,smbuf)))
    msg = getmud();
  cp = strstr(msg,smbuf);
  p1 = strstr(cp,"-");
  *p1 = '\0';
  sscanf(cp,"[%d] %d",&dummy,&mg);
  if (cg < mg)
    goal = cg;
  else
    goal = mg;
  return;
}

void parse_command(char *msg) {

  char commune[50];  
  char spell[255];
  char target[255];
  char buf[255];
  char *cp;
  char *cp2;
  char *uncles[] =
    {"Natrat","PSB","Daimon","Alpha","Duncan","Emanon","Lestat",
     "Baldar","Dane","Sagille","Firmlife","Gelderan","Videoman",
     "Hunter","enfan","Gurney","Aldur","Lefty","Hajima","Belgar",
     "Nathan","Wulf"};
  int num_uncles = 22;
  int i;

  if (strstr(msg," says ")) {
    sprintf(commune,"say");
  }
  else {
    cp = cp2 = strstr(msg," tells ");
    cp--;
    while ((*cp != ' ') && (*cp != '>') && (cp != msg))
      cp--;
    if (cp != msg)
      cp++;
    *cp2 = '\0';
    sprintf(commune,"tell %s",cp);
    *cp2 = ' ';
  }
  if ((strstr(msg,"report")) || (strstr(msg,"Report"))) {
    sprintf(buf,"%s H:%d/%d  M:%d/%d  V:%d/%d",commune,hps,maxhps,mana,maxmana,
	    v,maxv);
    sendmud(buf);
    sprintf(buf,"%s Exp: %d  Levels: M:%d C:%d",
	    commune,exp,mage_level,cleric_level);
    sendmud(buf);
    sprintf(buf,"%s Next level at %d exp.",commune,goal);
    sendmud(buf);
    return;
  }
  if ((strstr(msg,"light"))) {
    sendmud("cast \'continual light\'");
    sendmud("dro ball");
    return;
  }
  if ((strstr(msg,"food")) || (strstr(msg,"Food"))) {
    if (resting)
      sendmud("cast \'create food\'");
    else {
      sprintf(buf,"%s Sorry, I\'m busy right now.",commune);
      sendmud(buf);
    }
    return;
  }
  if ((strstr(msg,"stay")) && (strcmp(leader,"none"))) {
    sendmud("rest");
  }
  if ((strstr(msg,"heel")) && (strcmp(leader,"none"))) {
    sendmud("stand");
  }
  if ((strstr(msg,"drink")) || (strstr(msg,"Drink"))) {
    if (resting) {
      sendmud("get barrel");
      msg = getmud();
      while (!((strstr(msg,"You get the barrel")) || (strstr(msg,"You do not see a barrel here")) || (strstr(msg,"You get a barrel")) || (strstr(msg,"You can't carry that much"))))
        msg = getmud();
      if (strstr(msg,"You do not see a barrel here")) {
	sendmud("say Ok, who stole the community barrel?");
	sendmud("cast \'minor c\' barrel");
	return;
      }
      if (strstr(msg,"You can't carry that much")) {
	sendmud("say The community barrel is available for use.");
	sendmud("say If it is empty already, junk it and tell me drink again.");
	return;
      }
      else {
	sendmud("cast \'create w\' barrel");
	sendmud("cast \'create w\' barrel");
	sendmud("dro barrel");
	return;
      }
    }
    else {
      sprintf(buf,"%s I can\'t! I\'m in the middle of adventuring!",commune);
      sendmud(buf);
      return;
    }
  }
  if (strstr(msg,"help")) {
    sprintf(buf,"%s To get me to do stuff, tell me <command> or",commune);
    sendmud(buf);
    sprintf(buf,"%s say \'hobbes <command>\' in my presence.",commune);
    sendmud(buf);
    sprintf(buf,"%s Commands: light, food, drink, report",commune);
    sendmud(buf);
    sprintf(buf,"%s <target> needs <spell> =  cast <spell> on <target>",commune);
    sendmud(buf);
    sprintf(buf,"%s For info on my transportation service, tell me info.",commune);
    sendmud(buf);
    return;
  }
  if (strstr(msg,"info")) {
    sprintf(buf,"%s I will take you places: follow me, then make sure",commune);
    sendmud(buf);
    sprintf(buf,"%s you have needed spells (fly or inv), then tell me where:",commune);
    sendmud(buf);
    sprintf(buf,"%s newthalos, python, skexie, mordilnia, gypsy, shire, moria",commune);
    sendmud(buf);
    sprintf(buf,"%s oldthalos, pyramid",commune);
    sendmud(buf);
    return;
  }
  if (strstr(msg,"follow")) {
    if (!(cp=strstr(msg,"says")))
      cp = strstr(msg,"tells");
    cp--;
    cp2=cp;
    cp--;
    while((cp != msg) && (*cp != ' '))
      cp--;
    if (cp != msg)
      cp++;
    *cp2 = '\0';
    for (i=0; i<num_uncles; i++) {
      if (!strcmp(uncles[i],cp)) {
	sprintf(leader,"%s",cp);
	sprintf(buf,"fol %s",cp);
	sendmud(buf);
	break;
      }
    }
    if (i==num_uncles) {
      sprintf(buf,"%s I'm not allowed to group with strangers!",commune);
      sendmud(buf);
      sprintf(buf,"%s To become an uncle or aunt, send mail to:",commune);
      sendmud(buf);
      sprintf(buf,"%s jmci@andrew.cmu.edu, or see Natrat.",commune);
      sendmud(buf);
    }
    *cp2 = ' ';
    return;
  }
  if ((strstr(msg,"stop")) && (strcmp(leader,"none"))) {
    sendmud("vis");
    sendmud("return");
    sendmud("fol hobbes");
    sendmud("group hobbes");
    must_cast("word of recall","hobbes");
    sprintf(leader,"none");
    return;
  }
  if (strstr(msg,"summon")) {
    if (strcmp(leader,"none")) {
      sprintf(buf,"%s I can\'t, I am grouped with %s and it may not be safe.\n",
	      commune,leader);
      sendmud(buf);
      return;
    }
    if (strstr(commune,"say")) {
      sendmud("say You dolt, you are right here next to me already!");
      return;
    }
    sprintf(buf,"%s Ok, I\'ll give it a shot.",commune);
    sendmud(buf);
    if (!(cp=strstr(msg,"says")))
      cp = strstr(msg,"tells");
    cp--;
    cp2=cp;
    cp--;
    while((cp != msg) && (*cp != ' '))
      cp--;
    if (cp != msg)
      cp++;
    *cp2 = '\0';
    sendmud("d");
    sprintf(buf,"cast \'summon\' %s",cp);
    sendmud(buf);
    sendmud("u");
  }
  if (strstr(msg,"stash"))
    check_inventory(commune);
  if (strstr(msg,"locate")) {
    cp = strstr(msg,"locate");
    cp = strstr(cp," ");
    cp++;
    cp2 = strstr(cp,"\'");
    *cp2 = '\0';
    locate(commune,cp);
    *cp2 = '\'';
  }
  if (strstr(msg," needs ")) {
    cp = strstr(msg,"\'");
    *cp = ' ';
    cp = strstr(cp,"\'");
    *cp = '\0';
    if (strstr(msg,"say")) {
      cp = strstr(msg,"obbes");
      sscanf(cp,"obbes %s needs",target);
    }
    else {
      cp = strstr(msg,"tells you");
      sscanf(cp,"tells you %s needs",target);
    }
    cp = strstr(cp,"needs");
    while(*cp != ' ')
      cp++;
    cp++;
    sprintf(buf,"cast \'%s\' %s",cp,target);
    sendmud(buf);
    return;
  }
  if (strstr(msg,"do ")) {
    cp = strstr(msg,"do ");
    cp = strstr(cp,"\'");
    *cp = '\0';
    cp = strstr(msg,"do ");
    while (*cp != ' ')
      cp++;
    cp++;
    sprintf(buf,"%s",cp);
    sendmud(buf);
    return;
  }
  if (strstr(msg,"newthalos")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
      return;
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune,leader);
	sendmud(buf);
	return;
      }
      else {
	go_to(0);
	return;
      }
    }
  }
  if (strstr(msg,"python")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune);
	sendmud(buf);
      }
      else {
	go_to(1);
      }
    }
    return;
  }
  if (strstr(msg,"skexie")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune,leader);
	sendmud(buf);
      }
      else {
	go_to(2);
      }
    }
    return;
  }
  if (strstr(msg,"mordilnia")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune,leader);
	sendmud(buf);
      }
      else {
	go_to(3);
      }
    }
    return;
  }
  if (strstr(msg,"gypsy")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune,leader);
	sendmud(buf);
      }
      else {
	go_to(4);
      }
    }
    return;
  }
  if (strstr(msg,"shire")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune,leader);
	sendmud(buf);
      }
      else {
	go_to(5);
      }
    }
    return;
  }
  if (strstr(msg,"moria")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune,leader);
	sendmud(buf);
      }
      else {
	go_to(6);
      }
    }
    return;
  }
  if (strstr(msg,"oldthalos")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune,leader);
	sendmud(buf);
      }
      else {
	go_to(7);
      }
    }
    return;
  }
  if (strstr(msg,"pyramid")) {
    if (mana < 75) {
      sprintf(buf,"%s Sorry, I need to rest a bit first.",commune);
      sendmud(buf);
    }
    else {
      if (strcmp(leader,"none")) {
	sprintf(buf,"%s Not now, I am following %s.",commune,leader);
	sendmud(buf);
      }
      else {
	go_to(8);
      }
    }
    return;
  }
  return;
}    

void must_cast(char *spell, char *target) {

  char *msg;
  char buf[50];
  
  sprintf(buf,"cast \'%s\' %s",spell,target);
  sendmud(buf);
  msg=getmud();
  while(!(strstr(msg,SPELL_OK))) {
    if ((strstr(msg,SPELL_FAIL)) || (strstr(msg,"You can\'t summon enough")))
      sendmud(buf);
    msg=getmud();
  }
  return;
}

/* nt, python, skexie, mordilnia, gypsy, shire, moria, oldthalos, pyramid */
void go_to(int dest) {

  char buf[50];
  char outbuf[255];
  char *paths[] = {"dwseeegeeeeeeneennneneeeeeseeseeseeeeeeseseeeeneeeex",
                   "dwseeegeeeseessssx",
		   "dwsseesswwwwwwwwwwwsswsswssssssssdddwswdx",
		   "dwsseesswwwwwwwwwwwsswsssssssssssswssssx",
		   "dwseeegeeeeeeneennneneeeeeseeex",
		   "dwswwwgwwnnnnx",
		   "dwseeegeeennnnnnx",
                   "dwseeegeeeeeeneennneneeeeeseeseeseeeeeeseseeeeneeeereeeeessssssgsssswsswx",
                   "dwseeegeeeeeeneennneneeeeeseeseeseeeeeeseseeeeneeeereeeeessssssgssswnx"};
  char *mypath = paths[dest];
  char where[50];
  int i=0;
  
  switch(dest) {
    case 0: 
      sprintf(where,"New Thalos");
      break;
    case 1:
      sprintf(where,"Castle Python");
      break;
    case 2:
      sprintf(where,"Skexie Palace");
      break;
    case 3:
      sprintf(where,"Mordilnia");
      break;
    case 4:
      sprintf(where,"Gypsy Village");
      break;
    case 5:
      sprintf(where,"the Shire");
      break;
    case 6:
      sprintf(where,"Moria");
      break;
    case 7:
      sprintf(where,"Old Thalos");
      break;
    case 8:
      sprintf(where,"Pyramid");
      break;
  }
  get_stats();
  must_cast("fly","hobbes");
  must_cast("detect i","hobbes");
  must_cast("inv","hobbes");
  if (v < 80)
    must_cast("sec","hobbes");
  sendmud("say All aboard the Hobbes Express!");
  sprintf(outbuf,"say Next stop: %s",where);
  sendmud(outbuf);
  while(mypath[i] != 'x') {
    if (mypath[i] == 'g') {
      must_cast("knock","gate");
      sendmud("open gate");
    }
    else {
      if (mypath[i] == 'r') {
	must_cast("sec","hobbes");
      }
      else {
      sprintf(buf,"%c",mypath[i]);
      sendmud(buf);
      }
    }
    i++;
  }
  sendmud("say We have reached our final destination.");
  sendmud("say Thank you for riding the Hobbes Express.");
  must_cast("word of recall","hobbes");
  sendmud("vis");
  return;
}

void prac_help(char *target) {
  int spell_num;
  char outbuf[100];
  
  spell_num = random() % num_help;
  sprintf(outbuf,"cast \'%s\' %s",help_spells[spell_num],target);
  sendmud(outbuf);
  return;
}

void maintain_spells(void) {

  char *spells[] = {"detect i", "detect m", "detect e", "fly",
		    "str", "armor", "shield", "aid", "bless",
                    "true"};
  int num = 9;
  int i;
  char *msg;
  char buf[100];
  char allbuf[1000];

  sprintf(allbuf," ");
  sendmud("att");
  sendmud(GARBAGE);
  while (!strstr(msg=getmud(),"--------"));
  msg = getmud();
  while ((strstr(msg,"Spell :"))) {
    strcat(allbuf,msg);
    msg = getmud();
  }
  for (i=0; i<num; i++)
    if (!(strstr(allbuf,spells[i]))) {
      sprintf(buf,"cast \'%s\' hobbes",spells[i]);
      sendmud(buf);
    }
  return;
}
  
void check_inventory(char *commune) {

  char *msg;
  char buf[256];
  
  sendmud("i");
  while (!strstr(msg=getmud(),"You are carrying:"));
  sprintf(buf,"%s Here is what I\'ve got:",commune);
  sendmud(buf);
  msg = getmud();
  while (strstr(msg,"[")) {
    sprintf(buf,"%s %s",commune,msg);
    sendmud(buf);
    msg = getmud();
  }
  return;
}

void locate(char *commune, char *target) {

  char *msg;
  char buf[255];
  
  sprintf(buf,"cast \'locate o\' %s",target);
  sendmud(buf);
  msg=getmud();
  while(!strstr(msg,"Ok.")) {
    if (strstr(msg,"concentration")) {
      sprintf(buf,"%s Drat, I failed. Hold on a sec.\n",commune);
      sendmud(buf);
      sprintf(buf,"cast \'locate o\' %s",target);
      sendmud(buf);
    }
    if (strstr(msg,"Nothing at all by that name")) {
      sprintf(buf,"%s You silly, there\'s no such thing.",commune);
      sendmud(buf);
      return;
    }
    if (strstr(msg,"can\'t summon enough")) {
      sprintf(buf,"%s Sorry, I don\'t have enough mana to locate it now.",
	      commune);
      sendmud(buf);
      if (!strcmp(leader,"none"))
	sendmud("rest");
      return;
    }
    msg = getmud();
  }
  msg = getmud();
  while (!strstr(msg,PROMPT)) {
    if (strstr(msg,"Return to continue"))
      sendmud("");
    else {
      if (strcmp(msg,"")) {
	sprintf(buf,"%s %s",commune,msg);
	sendmud(buf);
      }
    }
    msg=getmud();
  }
  return;
}
