#include "robot.h"

/* global variables */
extern int sock;
extern int mana;
extern int maxmana;
extern int hps;
extern int maxhps;
extern int v;
extern int maxv;
extern int gold;
extern int exp;
extern int mage_level;
extern int cleric_level;
extern int goal;
extern int running;
extern int resting;
extern char leader[50];

void connect_mud(char *host, char *port) {
  int sock, connectresult;
  struct sockaddr_in sockaddr;
  struct hostent *hp;

  if(isdigit(*host)) {    /* check for numerical host address */
    sockaddr.sin_addr.s_addr=inet_addr(host);
  }
  else {
    hp = gethostbyname(host);
    memcpy((char *)&sockaddr.sin_addr, hp->h_addr, sizeof(sockaddr.sin_addr));
  }
  sockaddr.sin_port = htons(atoi(port));
  if ((sock=socket(AF_INET,SOCK_STREAM,0))<0) {
    fprintf(stderr,"Could not open socket.\n");
    exit(1);
  }
  sockaddr.sin_family = AF_INET;
  connectresult=connect(sock, &sockaddr, sizeof(sockaddr));
  if (connectresult) {
    close(sock);
    switch(errno) {
    case ECONNREFUSED: {
      fprintf(stderr,"Connection refused.\n");
      exit(1);
    }
    case ENETUNREACH: {
      fprintf(stderr,"Network unreachable.\n");
      exit(1);
    }
    default: {
      fprintf(stderr,"Couldn't connect.\n");
      exit(1);
    }
    }
  }
  fprintf(stderr,"Connection successful.\n");
}

void sendmud(char *msg) {

  int len;
  int count;
  int result;
  char buf[255];
  
  sprintf(buf,"%s\n",msg);
  len = strlen(buf);
  count = 0;
  while((result=write(sock,buf,len)) < len) {
    if ((result == -1) && (errno == EWOULDBLOCK)) {
      count++;
      sleep(1);
      if (count >= 30) {
	fprintf(stderr,"Write failure--30 second delay.\n");
	exit(1);
      }
    }
    else {
      fprintf(stderr,"Write failure.\n");
      exit(1);
    }
  }
  fprintf(stderr,"Sent: %s\n",msg);
  return;
}

char *getmud(void) {

  static char buf[256];
  char *cp1, *cp2;
  char tmpbuf[255];
  char smbuf[4];
  int result;
  int i;

  alarm(30);
  for(i=0;i<255;i++)
    tmpbuf[i] = buf[i] = '\0';
  i=0;
  while(i<255) {
    result = read(sock,smbuf,1);
    if (result < 0) {
      fprintf(stderr,"Read failure.");
      exit(1);
    }
    if (smbuf[0] == '\r')
      break;
    else
      tmpbuf[i++] = smbuf[0];
  }
  cp1 = tmpbuf;
  cp2 = buf;
  while(*cp1 != '\0') {
    if ((isprint(*cp1)) || (*cp1 == '\n'))
      *cp2++ = *cp1++;
    else
      cp1++;
  }
  *cp2 = '\0';
  fprintf(stderr,"Recd: %s",buf);
  return(buf);
}

void quitbot(void) {

  sendmud("return");
  sendmud("cast \'word of recall\'");
  sendmud("rent");
  sendmud("0");
  sleep(10);
  exit(0);
}

void alarmfunct(void) {
  
  sendmud("i");
  return;
}
